# Solana Architecture

- [Introduction](introduction.md)

- [Terminology](terminology.md)

- [Getting Started](getting-started.md)
  - [Example: Web Wallet](webwallet.md)

- [Programming Model](programs.md)
  - [Example: Tic-Tac-Toe](tictactoe.md)
  - [Drones](drones.md)

- [A Solana Cluster](cluster.md)
  - [Synchronization](synchronization.md)
  - [Leader Rotation](leader-rotation.md)
  - [Fork Generation](fork-generation.md)

- [Anatomy of a Fullnode](fullnode.md)
  - [TPU](tpu.md)
  - [TVU](tvu.md)
  - [Gossip Service](gossip.md)
  - [The Runtime](runtime.md)

- [Proposed Architectural Changes](proposals.md)
  - [Ledger Replication](ledger-replication.md)
  - [Secure Enclave](enclave.md)
  - [Staking Rewards](staking-rewards.md)
  - [Fork Selection](fork-selection.md)
  - [Entry Tree](entry-tree.md)

## Appendix

- [Appendix](appendix.md)
  - [JSON RPC API](jsonrpc-api.md)
  - [JavaScript API](javascript-api.md)
  - [solana-wallet CLI](wallet.md)
